import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 *
 * 
 * @author Benjamin Holzschuh
 * @version 12-6-2013
 */
public class Ship extends Actor
{
    //Booleans for the shooting and punishment mechanics repestively
    public boolean canShoot = true;
    public int shootTimer = 0;
    public boolean death = false;
    public int deathTimer = 50;
    
    public void act() 
    {
        controls();
        shotReset();
        edgeBlock();
        destroyStart();
    }    
    
    public void controls()
    {
        //Creates the side to side movement, assuming the "death" animation isn't playing
        if(Greenfoot.isKeyDown("right") && death == false)
        setLocation(getX()+2,getY());
        if(Greenfoot.isKeyDown("left") && death == false)
        setLocation(getX()-2,getY());
        
        Projectile projectile = new Projectile();
        //The code to shoot a projectile
        if(Greenfoot.isKeyDown("space") && canShoot == true && death == false)
        {
            getWorld().addObject(projectile,getX(),getY()-16);
            //These are parts of the shooting delay which is continued in the shotReset code string, this part resets the shooting variables to allow shotReset to work
            canShoot = false;
            shootTimer = 15;
        }

    }
    
    public void shotReset()
    {
        //This part checks to see if the shooting delay should be started and counts down the time for the delay
        if (canShoot == false)
        shootTimer -= 1;
        //Allows shooting once the delay has timed out
        if (shootTimer == 0 && canShoot == false)
        canShoot = true;
    }
    
    public void edgeBlock()
    {
        //Keeps the triangle image from going beyond the edges of the world
        if(getX()-getImage().getWidth()/2 <= 0)
        setLocation(getImage().getWidth()/2,getY());
        else if(getX()+getImage().getWidth()/2 >= getWorld().getWidth())
        setLocation(getWorld().getWidth()-getImage().getWidth()/2,getY());
    }
    
    public void destroyStart()
    {
        //Checks to see if the enemy projectile has hit the triangle
        Actor GProj = getOneIntersectingObject(EnemyProjectile.class);
        if (GProj != null && death == false)
        {
            death = true;
            //Disappears the triangle to allow the death animation to play
            getImage().setTransparency(0);
            //Removes the enemy projectile
            getWorld().removeObject(GProj);
            //Adds the death particle effects to the world
            DestructionParticle particle = new DestructionParticle();
            DestructionParticle particle2 = new DestructionParticle();
            DestructionParticle particle3 = new DestructionParticle();
            DestructionParticle particle4 = new DestructionParticle();
            getWorld().addObject(particle,getX(),getY());
            getWorld().addObject(particle2,getX(),getY());
            getWorld().addObject(particle3,getX(),getY());
            getWorld().addObject(particle4,getX(),getY());
        }
        
        if (death == true)
        {
           //counts down to repspawn
           deathTimer -= 1; 
        }
        
        if (deathTimer == 0)
        {
            //Respawns the triangle
            death = false;
            deathTimer = 50;
            getImage().setTransparency(255);
        }
    }
    
    
}